//+------------------------------------------------------------------+
//|                                              Converter(NaNs).mqh |
//|                               Copyright (c) 2019-2020, Marketeer |
//|                          https://www.mql5.com/en/users/marketeer |
//+------------------------------------------------------------------+

template<typename T1,typename T2>
union _L2D
{
  T1 L;
  T2 D;
};

template<typename T1,typename T2>
class Converter
{
  private:
    _L2D<T1,T2> L2D;
  
  public:
    T2 operator[](const T1 L)
    {
      L2D.L = L;
      return L2D.D;
    }

    T1 operator[](const T2 D)
    {
      L2D.D = D;
      return L2D.L;
    }
};


#define NAN_INF_PLUS  0x7FF0000000000000
#define NAN_INF_MINUS 0xFFF0000000000000
#define NAN_QUIET     0x7FF8000000000000
#define NAN_IND_MINUS 0xFFF8000000000000


#define NAN_QUIET_1   0x7FF8000000000001
#define NAN_QUIET_2   0x7FF8000000000002


static Converter<ulong,double> NaNs;
static double inf = NaNs[NAN_INF_PLUS];     // +infinity
static double infneg = NaNs[NAN_INF_MINUS]; // -infinity
static double nan = NaNs[NAN_QUIET];        // quiet NaN
static double nanind = NaNs[NAN_IND_MINUS]; // -nan(ind)

static double nanq1 = NaNs[NAN_QUIET_1];
static double nanq2 = NaNs[NAN_QUIET_2];

template<typename T>
T __getINF(T dummy)
{
  return new T(inf);
}

double __getINF(double dummy)
{
  return inf;
}

template<typename T>
T __getNAN(T dummy)
{
  return new T(nan);
}

double __getNAN(double dummy)
{
  return nan;
}
